﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinToolbars
Imports System.Windows.Forms
Imports System.Drawing

Public Class NABiToolbarsManager
    Inherits Infragistics.Win.UltraWinToolbars.UltraToolbarsManager
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseCaptionBelowImage As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseLargeImagesToolbar As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    ' ''' <summary>
    ' ''' NABi Style 설정
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-22 민유진 Created.
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 툴바 스타일 설정")> _
    'Public Property NABiUseToolbarStyle() As ENUM_TRUEFALSE

    '    Get
    '        Return meUseNABiStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseNABiStyle = Value
    '        NABiSetToolbarStyle()
    '    End Set
    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 툴바 스타일 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetToolbarStyle()
        End Set
    End Property

    ''' <summary>
    ''' NABi Style 설정
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created.
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 툴바 캡션을 이미지 아래로 내리는 여부")> _
    Public Property NABiCaptionBelowImage() As ENUM_TRUEFALSE

        Get
            Return meUseCaptionBelowImage
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseCaptionBelowImage = Value
            If meUseCaptionBelowImage = ENUM_TRUEFALSE.TRUE Then
                Me.ToolbarSettings.CaptionPlacement = Infragistics.Win.TextPlacement.BelowImage
            ElseIf meUseCaptionBelowImage = ENUM_TRUEFALSE.FALSE Then
                Me.ToolbarSettings.CaptionPlacement = Infragistics.Win.TextPlacement.Default
            End If
        End Set
    End Property

    ''' <summary>
    ''' NABi 툴바 이미지 Size 설정
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-26 민유진 Created.
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 툴바 이미지 Size 설정")> _
    Public Property NABiUseLargeImagesOnToolbar() As ENUM_TRUEFALSE

        Get
            Return meUseLargeImagesToolbar
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseLargeImagesToolbar = Value
            NABiToolbarImage(meUseLargeImagesToolbar)
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABi toolbar Style 지정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created.
    ''' </remarks>
    Private Sub NABiSetToolbarStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.CreationFilter = New CreatingUIElementCLS(ENUM_CONTROL.TOOLBAR)

            '움직이지 못하도록 고정함
            Me.ToolbarSettings.AllowCustomize = Infragistics.Win.DefaultableBoolean.False
            Me.ToolbarSettings.AllowDockBottom = Infragistics.Win.DefaultableBoolean.False
            Me.ToolbarSettings.AllowDockLeft = Infragistics.Win.DefaultableBoolean.False
            Me.ToolbarSettings.AllowDockRight = Infragistics.Win.DefaultableBoolean.False
            Me.ToolbarSettings.AllowDockTop = Infragistics.Win.DefaultableBoolean.False
            Me.ToolbarSettings.AllowFloating = Infragistics.Win.DefaultableBoolean.False

            'Toolbar 앞 뒤 Fix
            Me.ToolbarSettings.FillEntireRow = Infragistics.Win.DefaultableBoolean.True
            Me.LockToolbars = True


            '기본 ToolbarFont
            Me.ToolbarSettings.Appearance.FontData.SizeInPoints = 8
            Me.ToolbarSettings.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True

            'Toolbar는 LargeSize 로 보여주기
            Me.UseLargeImagesOnToolbar = True

            'Disable 색 지정
            Me.Appearance.ForeColorDisabled = Color.DarkGray

            Me.ImageSizeLarge = New Size(24, 24)

            '
            ' NABiAddToolbar()

        Else
            'NABiClearToolbar()

        End If

    End Sub

    ''' <summary>
    ''' Toolbar Image size 설정
    ''' </summary>
    ''' <param name="meUseToolbarImageSize"></param>
    ''' <remarks></remarks>
    Private Sub NABiToolbarImage(meUseToolbarImageSize As ENUM_TRUEFALSE)

        If meUseToolbarImageSize = ENUM_TRUEFALSE.TRUE Then
            Me.UseLargeImagesOnToolbar = True
        Else
            Me.UseLargeImagesOnToolbar = False
        End If

    End Sub

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle

    End Sub

#End Region

#Region " Custom Tool "

    Private Shared moToolFactory As ToolFactory = Nothing

    Friend Shared ReadOnly CUSTOMBUTTON_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5411")
    Friend Shared ReadOnly CUSTOMCOMBOBOX_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5412")
    Friend Shared ReadOnly CUSTOMCONTROLCONTAINER_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5413")
    Friend Shared ReadOnly CUSTOMFONTLIST_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5414")
    Friend Shared ReadOnly CUSTOMLABEL_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5415")
    Friend Shared ReadOnly CUSTOMLIST_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5416")
    Friend Shared ReadOnly CUSTOMMDIWINDOWLIST_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5417")
    Friend Shared ReadOnly CUSTOMPOPUPCONTROLCONTAINER_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5418")
    Friend Shared ReadOnly CUSTOMPOPUPMENU_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5419")
    Friend Shared ReadOnly CUSTOMSTATEBUTTON_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5420")
    Friend Shared ReadOnly CUSTOMTEXTBOX_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5421")

    Shared Sub New()
        moToolFactory = New ToolFactory()
    End Sub

    Private Class ToolFactory
        Implements IToolProvider

        Friend Sub New()
            Dim result As Boolean

            ' Register some custom tool types with UltraToolbarsManager.
            Try
                ' CustomButtonTool class.
                result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMBUTTON_TOOLID, "Custom Button", "CustomButtonTool")
                If result = False Then
                    MessageBox.Show("Error registering CustomButtonTool class!")
                End If

                '' CustomComboBoxTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMCOMBOBOX_TOOLID, "Custom ComboBox", "CustomComboBoxTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomComboBoxTool class!")
                'End If

                '' CustomControlContainerTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMCONTROLCONTAINER_TOOLID, "Custom ControlContainer", "CustomControlContainerTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomControlContainerTool class!")
                'End If

                '' CustomFontListTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMFONTLIST_TOOLID, "Custom FontList", "CustomFontListTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomFontListTool class!")
                'End If

                '' CustomLabelTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMLABEL_TOOLID, "Custom Label", "CustomLabelTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomLabelTool class!")
                'End If

                '' CustomListTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMLIST_TOOLID, "Custom List", "CustomListTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomListTool class!")
                'End If

                '' CustomMDIWindowListTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMMDIWINDOWLIST_TOOLID, "Custom MDIWindowList", "CustomMDIWindowListTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomMDIWindowListTool class!")
                'End If

                '' CustomPopupControlContainerTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMPOPUPCONTROLCONTAINER_TOOLID, "Custom PopupControlContainer", "CustomPopupControlContainerTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomPopupControlContainerTool class!")
                'End If

                '' CustomPopupMenuTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMPOPUPMENU_TOOLID, "Custom PopupMenu", "CustomPopupMenuTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomPopupMenuTool class!")
                'End If

                '' CustomStateButtonTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMSTATEBUTTON_TOOLID, "Custom StateButton", "CustomStateButtonTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomStateButtonTool class!")
                'End If

                '' CustomTextBoxTool class.
                'result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMTEXTBOX_TOOLID, "Custom TextBox", "CustomTextBoxTool")
                'If result = False Then
                '    MessageBox.Show("Error registering CustomTextBoxTool class!")
                'End If
            Catch
                '2016.01.22 이재영
                '아래 주석 및 수정 : Do nothing.
                'MessageBox.Show("Error registering custom tool classes!")
            End Try

        End Sub


        '/ <summary>
        '/ Creates and returns an instance of the tool identified by the specified GUID id.
        '/ </summary>
        '/ <param name="toolID">The Guid identifier specified for the tool when it was registered.</param>
        '/ <param name="key">The key assigned to the tool.</param>
        '/ <returns>A new instance of the specified tool.</returns>
        Function CreateToolInstance(ByVal toolID As Guid, ByVal key As String) As ToolBase Implements IToolProvider.CreateToolInstance
            'If toolID.Equals(CUSTOMBUTTON_TOOLID) Then
            '    Return New ToolProvider.CustomButtonTool(key)
            'End If

            'If toolID.Equals(CUSTOMCOMBOBOX_TOOLID) Then
            '    Return New ToolProvider.CustomComboBoxTool(key)
            'End If

            Select Case toolID
                Case CUSTOMBUTTON_TOOLID
                    Return New ToolProvider.CustomButtonTool(key)
                    'Case CUSTOMCOMBOBOX_TOOLID
                    '    Return New ToolProvider.CustomComboBoxTool(key)
                    'Case CUSTOMCONTROLCONTAINER_TOOLID
                    '    Return New ToolProvider.CustomControlContainerTool(key)
                    'Case CUSTOMFONTLIST_TOOLID
                    '    Return New ToolProvider.CustomFontListTool(key)
                    'Case CUSTOMLABEL_TOOLID
                    '    Return New ToolProvider.CustomLabelTool(key)
                    'Case CUSTOMLIST_TOOLID
                    '    Return New ToolProvider.CustomListTool(key)
                    'Case CUSTOMMDIWINDOWLIST_TOOLID
                    '    Return New ToolProvider.CustomMDIWindowListTool(key)
                    'Case CUSTOMPOPUPCONTROLCONTAINER_TOOLID
                    '    Return New ToolProvider.CustomPopupControlContainerTool(key)
                    'Case CUSTOMPOPUPMENU_TOOLID
                    '    Return New ToolProvider.CustomPopupMenuTool(key)
                    'Case CUSTOMSTATEBUTTON_TOOLID
                    '    Return New ToolProvider.CustomStateButtonTool(key)
                    'Case CUSTOMTEXTBOX_TOOLID
                    '    Return New ToolProvider.CustomTextboxTool(key)
                Case Else
                    ' The tool ID is unknown to us so return null.
                    Return Nothing
            End Select

            ' The tool ID is unknown to us so return null.
            'Return Nothing

        End Function

    End Class

#End Region

End Class
